VERSION 5.00
Begin VB.Form frmRegistry 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Registry Retrieval/Set Example"
   ClientHeight    =   3390
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6105
   Icon            =   "frmRegistry.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3390
   ScaleWidth      =   6105
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3015
      TabIndex        =   8
      Top             =   2895
      Width           =   1440
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   375
      Left            =   4515
      TabIndex        =   9
      Top             =   2895
      Width           =   1440
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1515
      TabIndex        =   7
      Top             =   2895
      Width           =   1440
   End
   Begin VB.TextBox txtActiveX 
      Height          =   315
      Left            =   135
      TabIndex        =   6
      Top             =   2370
      Width           =   5805
   End
   Begin VB.TextBox txtCookies 
      Height          =   315
      Left            =   135
      TabIndex        =   4
      Top             =   1575
      Width           =   5805
   End
   Begin VB.TextBox txtCache 
      Height          =   315
      Left            =   135
      TabIndex        =   2
      Top             =   795
      Width           =   5805
   End
   Begin VB.Label lblInfo 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "modRegistry by GSerg, example by hCORe [hCORe@mail.ru]"
      Height          =   195
      Left            =   1620
      TabIndex        =   0
      Top             =   135
      Width           =   4305
   End
   Begin VB.Label lblActiveX 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "ActiveX Cache:"
      Height          =   195
      Left            =   135
      TabIndex        =   5
      Top             =   2070
      Width           =   1110
   End
   Begin VB.Label lblHistory 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Internet Cookies:"
      Height          =   195
      Left            =   135
      TabIndex        =   3
      Top             =   1275
      Width           =   1200
   End
   Begin VB.Label lblCache 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Internet Cache:"
      Height          =   195
      Left            =   135
      TabIndex        =   1
      Top             =   495
      Width           =   1095
   End
End
Attribute VB_Name = "frmRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' modRegistry : GSerg [  , vbstreets,   %) ]
' :       hCORe [ hCORe@mail.ru ]

' "     
'      
'  " " -     !.."

' 
Option Explicit

Private Sub cmdApply_Click()
    '
    SaveValues
End Sub

Private Sub cmdCancel_Click()
    '
    Unload Me
End Sub

Private Sub cmdOK_Click()
    '  
    SaveValues
    Unload Me
End Sub

Private Sub Form_Load()
    '       Tag  
    txtCache.Tag = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Cache\Paths\Directory"
    txtCookies.Tag = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Cache\Special Paths\Cookies\Directory"
    txtActiveX.Tag = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\ActiveX Cache\0"
    
    '
    LoadValues
End Sub

Private Sub SaveValues()
' 

    Dim ctl As Control
    '  
    For Each ctl In Me
        '   
        If TypeOf ctl Is TextBox Then
            '  
            modRegistry.Value(GetRHKey(ctl.Tag), _
            GetRPath(ctl.Tag), GetRKey(ctl.Tag), REG_SZ) = ctl.Text
        End If
    Next ctl
End Sub

Private Sub LoadValues()
' 

    Dim ctl As Control
    '  
    For Each ctl In Me
        '   
        If TypeOf ctl Is TextBox Then
            '  
            ctl.Text = modRegistry.Value(GetRHKey(ctl.Tag), _
            GetRPath(ctl.Tag), GetRKey(ctl.Tag), REG_SZ)
        End If
    Next ctl
End Sub

'     
Private Function GetRKey(sTag As String) As String
    Dim i As Long
    i = InStrRev(sTag, "\")
    GetRKey = Mid$(sTag, i + 1)
    If Len(GetRKey) = 0 Then GetRKey = vbNullString
End Function

'   (hive key [root key])   
Private Function GetRHKey(sTag As String) As RegRoots
    Dim i As Long, sKey As String
    i = InStr(1, sTag, "\")
    sKey = UCase$(Left$(sTag, i - 1))
    If sKey = "HKEY_LOCAL_MACHINE" Then GetRHKey = HKEY_LOCAL_MACHINE
    If sKey = "HKEY_CURRENT_USER" Then GetRHKey = HKEY_CURRENT_USER
    If sKey = "HKEY_CLASSES_ROOT" Then GetRHKey = HKEY_CLASSES_ROOT
    If sKey = "HKEY_USERS" Then GetRHKey = HKEY_USERS
    If sKey = "HKEY_PERFORMANCE_DATA" Then GetRHKey = HKEY_PERFORMANCE_DATA
    If sKey = "HKEY_DYN_DATA" Then GetRHKey = HKEY_DYN_DATA
    If sKey = "HKEY_CURRENT_CONFIG" Then GetRHKey = HKEY_CURRENT_CONFIG
End Function

'      
Private Function GetRPath(sTag As String) As String
    Dim i As Long, n As Long
    i = InStr(1, sTag, "\")
    n = InStrRev(sTag, "\")
    GetRPath = Mid$(sTag, i + 1, n - i - 1)
End Function
